From:  Yan Lei <yan_lei@dahuatech.com>
Date: Fri, 25 Mar 2022 15:50:00 +0800
Subject: [PATCH] block: fix free after use of bio

mainline inclusion
category: bugfix
bugzilla: https://gitee.com/openeuler/kernel/issues/I4ZKXP
CVE: NA

----------------------------------------------------------
A pointer to freed memory is dereferenced, used as a function argument, or otherwise used (CWE-416)
"bio_put" frees "bio",Calling "bio_release_pages" dereferences freed pointer "bio".

Signed-off-by: Yan Lei <yan_lei@dahuatech.com>

---
 block/blk-map.c | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

diff --git a/block/blk-map.c b/block/blk-map.c
index ede73f4f7..23450c362
--- a/block/blk-map.c
+++ b/block/blk-map.c
@@ -316,7 +316,7 @@ static int bio_map_user_iov(struct request *rq, struct iov_iter *iter,
 	bounce_bio = bio;
 	ret = blk_rq_append_bio(rq, &bounce_bio);
 	if (ret)
-		goto out_put_orig;
+		goto out_unmap;
 
 	/*
 	 * We link the bounce buffer in and could have to traverse it
@@ -325,8 +325,6 @@ static int bio_map_user_iov(struct request *rq, struct iov_iter *iter,
 	bio_get(bounce_bio);
 	return 0;
 
- out_put_orig:
-	bio_put(bio);
  out_unmap:
 	bio_release_pages(bio, false);
 	bio_put(bio);
-- 
2.30.0

